// practica 1.4
/*PRACTICA DE SIERPINSKI DE OPENGL*/



/* Creada por Jose Mariscal Prieto.
	i72maprj@uco.es
*/
#include<windows.h>
#include<gl/Gl.h>
#include<gl/glut.h>
#include<gl/glu.h>

#define screenWidth  400 // Ancho
#define screenHeight 400 // Alto


//______________________________________________________________ 

class GLintPoint 
{ 
    public: 
       GLint x, y; 
}; 

//______________________________________________________________

int RandNum(int m) // funcion aleatoria
{ 
 return rand() % m; 
} 


//______________________________________________________________

void DrawDot(GLint x, GLint y)  // funcion que pinta los puntos.
{ 
    glBegin(GL_POINTS); 
        glVertex2i(x, y); 
    glEnd(); 
} 

//______________________________________________________________

void Sierpinski(void) 
{ 
    //Coordenadas del tringulo inicial

    GLintPoint T[3] = {{50, 60}, {340, 80}, {240, 350}}; 

    int index = RandNum(3); 
    GLintPoint point = T[index]; 
    DrawDot(point.x, point.y); 	  
    
	for (int i = 0; i < 50000; ++i) 
    { 
        index = RandNum(3); 
        point.x = (point.x + T[index].x) / 2; 
        point.y = (point.y + T[index].y) / 2; 
        DrawDot(point.x, point.y); 
     } 
     glFlush(); 
} 

//______________________________________________________________

void myDisplay(void) 
{ 
    glClear(GL_COLOR_BUFFER_BIT);           // limpia pantalla 
    Sierpinski(); 
    glFlush(); 
} 

//______________________________________________________________

void myInit() 
{ 
        glClearColor(1.0f,1.0f,1.0f,1.0f);  // Color de fondo
        glColor3f(0.0f,0.8f,0.8f);          // Color del pixel 
        glPointSize(1.0);                    //tamao del pixel 
        glMatrixMode(GL_PROJECTION); 
        glLoadIdentity();
		gluOrtho2D(0.0, screenWidth, 0.0, screenHeight);
        
} 

//______________________________________________________________

void main(int argc, char **argv) 
{ 
   ;    glutInit(&argc, argv); 
        glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB); 
        glutInitWindowSize(screenWidth, screenHeight); 
        glutInitWindowPosition(100, 100); 
        glutCreateWindow("Practica de Sierpinski"); 
        glutDisplayFunc(myDisplay); 
        myInit(); 
        glutMainLoop(); 
} 
  

